import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetDeviceRegistrationRequest, GetDeviceRegistrationResult } from "../models/models_0";
import { deserializeAws_restJson1GetDeviceRegistrationCommand, serializeAws_restJson1GetDeviceRegistrationCommand, } from "../protocols/Aws_restJson1";
var GetDeviceRegistrationCommand = (function (_super) {
    __extends(GetDeviceRegistrationCommand, _super);
    function GetDeviceRegistrationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetDeviceRegistrationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "SagemakerEdgeClient";
        var commandName = "GetDeviceRegistrationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetDeviceRegistrationRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetDeviceRegistrationResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetDeviceRegistrationCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetDeviceRegistrationCommand(input, context);
    };
    GetDeviceRegistrationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetDeviceRegistrationCommand(output, context);
    };
    return GetDeviceRegistrationCommand;
}($Command));
export { GetDeviceRegistrationCommand };
