import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SendHeartbeatRequest } from "../models/models_0";
import { deserializeAws_restJson1SendHeartbeatCommand, serializeAws_restJson1SendHeartbeatCommand, } from "../protocols/Aws_restJson1";
var SendHeartbeatCommand = (function (_super) {
    __extends(SendHeartbeatCommand, _super);
    function SendHeartbeatCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SendHeartbeatCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "SagemakerEdgeClient";
        var commandName = "SendHeartbeatCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SendHeartbeatRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SendHeartbeatCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1SendHeartbeatCommand(input, context);
    };
    SendHeartbeatCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1SendHeartbeatCommand(output, context);
    };
    return SendHeartbeatCommand;
}($Command));
export { SendHeartbeatCommand };
