import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { GetDeviceRegistrationRequest, GetDeviceRegistrationResult } from "../models/models_0";
import { SagemakerEdgeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../SagemakerEdgeClient";
export interface GetDeviceRegistrationCommandInput extends GetDeviceRegistrationRequest {
}
export interface GetDeviceRegistrationCommandOutput extends GetDeviceRegistrationResult, __MetadataBearer {
}

export declare class GetDeviceRegistrationCommand extends $Command<GetDeviceRegistrationCommandInput, GetDeviceRegistrationCommandOutput, SagemakerEdgeClientResolvedConfig> {
    readonly input: GetDeviceRegistrationCommandInput;
    constructor(input: GetDeviceRegistrationCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: SagemakerEdgeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetDeviceRegistrationCommandInput, GetDeviceRegistrationCommandOutput>;
    private serialize;
    private deserialize;
}
