import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { SendHeartbeatRequest } from "../models/models_0";
import { SagemakerEdgeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../SagemakerEdgeClient";
export interface SendHeartbeatCommandInput extends SendHeartbeatRequest {
}
export interface SendHeartbeatCommandOutput extends __MetadataBearer {
}

export declare class SendHeartbeatCommand extends $Command<SendHeartbeatCommandInput, SendHeartbeatCommandOutput, SagemakerEdgeClientResolvedConfig> {
    readonly input: SendHeartbeatCommandInput;
    constructor(input: SendHeartbeatCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: SagemakerEdgeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<SendHeartbeatCommandInput, SendHeartbeatCommandOutput>;
    private serialize;
    private deserialize;
}
