import { ExceptionOptionType as __ExceptionOptionType } from "@aws-sdk/smithy-client";
import { SagemakerEdgeServiceException as __BaseException } from "./SagemakerEdgeServiceException";
export interface GetDeviceRegistrationRequest {
    
    DeviceName: string | undefined;
    
    DeviceFleetName: string | undefined;
}
export declare namespace GetDeviceRegistrationRequest {
    
    const filterSensitiveLog: (obj: GetDeviceRegistrationRequest) => any;
}
export interface GetDeviceRegistrationResult {
    
    DeviceRegistration?: string;
    
    CacheTTL?: string;
}
export declare namespace GetDeviceRegistrationResult {
    
    const filterSensitiveLog: (obj: GetDeviceRegistrationResult) => any;
}

export declare class InternalServiceException extends __BaseException {
    readonly name: "InternalServiceException";
    readonly $fault: "client";
    Message?: string;
    
    constructor(opts: __ExceptionOptionType<InternalServiceException, __BaseException>);
}

export interface EdgeMetric {
    
    Dimension?: string;
    
    MetricName?: string;
    
    Value?: number;
    
    Timestamp?: Date;
}
export declare namespace EdgeMetric {
    
    const filterSensitiveLog: (obj: EdgeMetric) => any;
}

export interface Model {
    
    ModelName?: string;
    
    ModelVersion?: string;
    
    LatestSampleTime?: Date;
    
    LatestInference?: Date;
    
    ModelMetrics?: EdgeMetric[];
}
export declare namespace Model {
    
    const filterSensitiveLog: (obj: Model) => any;
}
export interface SendHeartbeatRequest {
    
    AgentMetrics?: EdgeMetric[];
    
    Models?: Model[];
    
    AgentVersion: string | undefined;
    
    DeviceName: string | undefined;
    
    DeviceFleetName: string | undefined;
}
export declare namespace SendHeartbeatRequest {
    
    const filterSensitiveLog: (obj: SendHeartbeatRequest) => any;
}
